Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 674)
+++ trunk/kernel/devices/dev_nic.c	(revision 683)
@@ -1354,13 +1531,13 @@
                 else if( socket_state == TCP_STATE_FIN_WAIT1 )
                 {
-                    if( seg_fin_set )  // received ACK & FIN
+                    if( seg_fin_set ) 
                     { 
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : FIN-ACK => goes CLOSING\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
-#endif
-                        // update socket.rx_nxt when FIN received
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : FIN-ACK => goes CLOSING\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+                        // update socket.rx_nxt 
                         hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_nxt ),
                                         socket_rx_nxt + 1 ); 
@@ -1370,5 +1547,5 @@
                                         TCP_STATE_CLOSING );
 
-                        // make an ACK request to R2T queue
+                        // send ACK request to remote
                         socket_put_r2t_request( socket_r2tq_xp,
                                                 TCP_FLAG_ACK,
@@ -1379,7 +1556,7 @@
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : only ACK => goes FIN_WAIT2\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : only ACK => goes FIN_WAIT2\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
                         // update socket state
@@ -1394,7 +1571,7 @@
 
 #if DEBUG_DEV_NIC_RX
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s : FIN-ACK => goes CLOSED / unblock client\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str(socket_state) );
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] socket[%x,%d] %s : FIN-ACK => goes CLOSED / unblock client\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
                         // update socket.rx_nxt when FIN received
@@ -1438,5 +1615,5 @@
                     dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
                 }
-            }  // end case connecteded states
+            }  // end case connected states
         }  // end switch socket state
 
@@ -1491,10 +1668,13 @@
         {
 
-#if DEBUG_DEV_NIC_RX
-fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ) );
-pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ) );
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] matching listening socket[%d,%d] / state %s\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, socket_state_str(socket_state) );
+#if DEBUG_DEV_NIC_RX || DEBUG_DEV_NIC_ERROR
+fdid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ) );
+pid   = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ) );
+#endif
+
+#if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
+printk("\n[%s] matching listening socket[%d,%d] / state %s\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
             break;
@@ -1509,38 +1689,46 @@
     {
         // The actions depend on the received segment flags
-        // - discard segment for RST or ACK
-        // - update socket state & remote IP address, 
-        //   register connect request in socket CRQ queue,
-        //   and unblock client thread for SYN 
+        // - discard segment for RST or ACK, 
+        // - for SYN, register the connect request in listening socket CRQ queue,
+        //   and  unblock the client thread in case of pending RX_ACCEPT command. 
  
-        // discard segment if RST flag
-        if( seg_rst_set )
+        // [1] check RST
+        if( seg_rst_set )       // discard segment
         {
 
-#if DEBUG_DEV_NIC_RX
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] for listening socket[%x,%d] : received RST\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s / received RST => discard segment\n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
 #endif
             return;
         }
 
-        // discard segment if ACK flag
-        if( seg_ack_set ) 
+        // [2] check ACK
+        if( seg_ack_set )    // send RST to remote
         {
 
-#if DEBUG_DEV_NIC_RX
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] for listening socket[%x,%d] : received ACK\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
-#endif
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : socket[%x,%d] %s received ACK => send RST & discard \n",
+__FUNCTION__, pid, fdid, socket_state_str(socket_state) );
+#endif
+            // make an RST request to R2T queue
+            socket_put_r2t_request( socket_r2tq_xp,
+                                    TCP_FLAG_RST,
+                                    chdev->channel );
             return;
         }
 
-        // SYN flag == CONNECT request / seq_num cannot be wrong
+        // [3] handle security & precedence TODO ... someday
+
+        // handle SYN == CONNECT request
         if( seg_syn_set )
         {
-            // build extended pointer on listening socket CRQ
+            // build extended pointers on various listening socket fields
+            socket_lock_xp = XPTR( socket_cxy , &socket_ptr->lock );
             socket_crqq_xp = XPTR( socket_cxy , &socket_ptr->crqq );
+            socket_r2tq_xp = XPTR( socket_cxy , &socket_ptr->r2tq );
+
+            // take the lock protecting the matching socket
+            remote_queuelock_acquire( socket_lock_xp );
 
             // try to register request into CRQ queue
@@ -1550,12 +1738,10 @@
                                             seg_seq_num,
                                             seg_window );
-
             if ( error )   // CRQ full
             {
 
-#if DEBUG_DEV_NIC_RX
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] listening socket[%x,%d] CRQ full => send RST\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : listening socket[%x,%d] %s receive SYN but CRQ full => send RST\n",
+__FUNCTION__, pid, fdid );
 #endif
                 // make an RST request to R2T queue 
@@ -1564,41 +1750,49 @@
                                         chdev->channel );
             }
-            else          // new connection request registered in CRQ
+            else          // register request in listening socket CRQ
             {
 
 #if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
 if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] for listening socket[%x,%d] : register request in CRQ\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
-#endif
-                // check pending RX_ACCEPT command
-                if( (hal_remote_l32(XPTR(socket_cxy,&socket_ptr->rx_valid)) == true) &&
-                    (hal_remote_l32(XPTR(socket_cxy,&socket_ptr->rx_cmd)) == CMD_RX_ACCEPT) )
+printk("\n[%s] listening socket[%x,%d] register request in CRQ\n",
+__FUNCTION__, pid, fdid );
+#endif
+                bool_t   rx_valid = hal_remote_l32( XPTR(socket_cxy , &socket_ptr->rx_valid));
+                uint32_t rx_cmd   = hal_remote_l32( XPTR(socket_cxy , &socket_ptr->rx_cmd));
+                
+                // check pending ACCEPT command
+                if( rx_valid && (rx_cmd == CMD_RX_ACCEPT) )
                 {
                     // reset rx_valid
                     hal_remote_s32( XPTR( socket_cxy , &socket_ptr->rx_valid ), false );
                      
-                    // report success to RX client thread
+                    // report success to RX client thread, that will
+                    // create a new socket and request a SYN-ACK to TX server thread
                     dev_nic_unblock_rx_client( socket_xp , CMD_STS_SUCCESS );
 
 #if DEBUG_DEV_NIC_RX
+if( DEBUG_DEV_NIC_RX < cycle )
 if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] for listening socket[%x,%d] unblock RX client thread\n", 
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid );
+printk("\n[%s] listening socket[%x,%d] unblock RX client thread\n", 
+__FUNCTION__, fdid );
 #endif
                 }
             }   // end register request in CRQ
+
+            // release the lock protecting the matching socket
+            remote_queuelock_release( socket_lock_xp );
+
         }   // end if SYN
-        
+
         return;
 
     }  // end if listening_match
 
-    // 6. no socket found => discard segment
-
-#if DEBUG_DEV_NIC_RX
-if( cycle > DEBUG_DEV_NIC_RX )
-printk("\n[%s] thread[%x,%x] exit failure : no socket found => discard segment\n",
-__FUNCTION__, this->process->pid, this->trdid );
+    // 6. no attached socket found and no listening socket found => discard segment
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : thread[%x,%d] / unexpected TCP segment => discard / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, chdev->channel, cycle ); 
 #endif
 
@@ -1618,5 +1812,5 @@
 
     thread_t    * this = CURRENT_THREAD;
-
+    
 // check thread can yield
 thread_assert_can_yield( this , __FUNCTION__ );
@@ -1626,10 +1820,17 @@
 "illegal chdev type or direction" );
 
-#if DEBUG_DEV_NIC_RX
-uint32_t   cycle = (uint32_t)hal_get_cycles();
+#if DEBUG_DEV_NIC_RX || DEBUG_DEV_NIC_ERROR
+uint32_t cycle = (uint32_t)hal_get_cycles();
+#endif
+
+#if DEBUG_DEV_NIC_RX
 if( cycle > DEBUG_DEV_NIC_RX )
 printk("\n[%s] thread[%x,%x] starts / cycle %d\n",
 __FUNCTION__, this->process->pid, this->trdid, cycle );
 #endif
+
+    // avoid warning
+    ip_length = 0;
+    error     = 0;
 
     // get extended pointers on server tread and chdev 
@@ -1674,5 +1875,10 @@
 __FUNCTION__, this->process->pid, this->trdid, cycle );
 #endif
-
+            // check possible error reported by NIC ISR
+            if( this->nic_cmd.error )  
+            {
+                printk("\n[PANIC] in %s : %s DMA engine cannot access RX_QUEUE / cycle %d\n",
+                __FUNCTION__, chdev->name , (uint32_t)hal_get_cycles() );
+            }
         }
         else                 // success => handle packet
@@ -1682,9 +1888,4 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_DEV_NIC_RX < cycle )
-dev_nic_packet_display( false,               // is_tx
-                        this->process->pid,
-                        this->trdid,
-                        cycle,
-                        k_buf );
 #endif
 
@@ -1697,8 +1898,6 @@
             {
 
-#if DEBUG_DEV_NIC_RX
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_NIC_RX < cycle )
-printk("\n[%s] thread[%x,%x] discard ETH packet / cycle %d\n", 
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[WARNING] in %s : thread[%x,%x] discard ETH packet / cycle %d\n", 
 __FUNCTION__, this->process->pid, this->trdid, cycle );
 #endif
@@ -1723,8 +1922,6 @@
             {
 
-#if DEBUG_DEV_NIC_RX
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_DEV_NIC_RX < cycle )
-printk("\n[%s] thread[%x,%x] discarded IP packet / cycle %d\n", 
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[WARNING] in %s : thread[%x,%x] discard IP packet / cycle %d\n", 
 __FUNCTION__, this->process->pid, this->trdid, cycle );
 #endif
@@ -1762,15 +1959,15 @@
             {
  
-#if DEBUG_DEV_NIC_RX
+#if DEBUG_DEV_NIC_ERROR
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_DEV_NIC_RX < cycle )
-printk("\n[%s] thread[%x,%x] discarded unsupported transport protocol %d\n", 
+printk("\n[WARNING] in %s : thread[%x,%x] unsupported transport protocol %d / cycle %d\n", 
 __FUNCTION__, this->process->pid, this->trdid, trsp_protocol, cycle );
 #endif
                 continue;
             }
-        }
-    } // end of while loop
-}  // end dev_nic_rx_server()
+        }   // end else success
+    }   // end of while loop
+}   // end dev_nic_rx_server()
 
 
@@ -1782,5 +1979,5 @@
 
 ///////////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the dev_nic_tx_build_packet() function.
+// This static function is called by the dev_nic_tx_send_packet() function.
 // It moves one ETH/IP/UDP packet from the kernel buffer identified by the <buffer> and 
 // <length> arguments to the NIC_TX_QUEUE identified the <chdev> argument.
@@ -1816,4 +2013,5 @@
     this->nic_cmd.buffer = k_buf;
     this->nic_cmd.length = length;
+    this->nic_cmd.error  = 0;
 
     while( 1 )
@@ -1868,5 +2066,5 @@
 // <socket_xp> argument. The <length> argument defines the number of bytes in payload.
 // It set the "src_port", "dst_port", "total_length" and "checksum" fields in UDP header.
-// The payload must be previouly loaded in the pernel buffer.
+// The payload must be previouly loaded in the kernel buffer.
 ///////////////////////////////////////////////////////////////////////////////////////////
 // @ k_buf      : [in]  pointer on first byte of UDP header in kernel buffer.
@@ -1904,4 +2102,8 @@
     k_buf[3] = remote_port; 
 
+    // reset checksum
+    k_buf[6] = 0;
+    k_buf[7] = 0;
+
     // set packet length in header
     k_buf[4] = total_length >> 8;
@@ -1909,6 +2111,9 @@
     
     // compute UDP packet checksum
-    checksum = dev_nic_udp_checksum( k_buf , total_length );
-
+    checksum = dev_nic_tcp_udp_checksum( k_buf,
+                                         total_length,
+                                         local_addr,
+                                         remote_addr,
+                                         false );       // is_not_tcp
     // set checksum
     k_buf[6] = checksum >> 8;
@@ -1920,5 +2125,5 @@
 // This static function is called by the dev_nic_tx_server() function. 
 // It builds a TCP header in the kernel buffer defined by the <k_buf> argument.
-// The payload must have been previouly registered in this buffer.
+// The payload must have been previouly registered in this buffer (for checksum).
 // The "local_addr", "local_port", "remote_addr", "remote_port", seq_num", "ack_num",
 // and "window" fields are obtained from the <socket_xp> argument.
@@ -1999,8 +2204,9 @@
   
     // compute TCP segment checksum
-    checksum = dev_nic_tcp_checksum( k_buf,
-                                     total_length,
-                                     src_addr,
-                                     dst_addr );
+    checksum = dev_nic_tcp_udp_checksum( k_buf,
+                                         total_length,
+                                         src_addr,
+                                         dst_addr,
+                                         true );       // is_tcp
     // set "checksum"
     k_buf[16] = checksum >> 8;
@@ -2108,53 +2314,44 @@
 }  // end dev_nic_tx_build_eth_header()
 
-///////////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the dev_nic_tx_server() function to handle one TX 
-// command, or one R2T request, as defined by the <cmd_valid> and <r2t_valid> arguments,
-// for the socket identified by the <socket_xp> argument. It builds an ETH/IP/UDP packet 
-// or ETH/IP/TCP segment, in the buffer defined by the <k_buf> argument, and registers
-// it in the NIC_TX queue defined by the <chdev> argument. 
-// For a TCP header, the "seq_num", ack_num", and "window" fiels are defined by the
-// "socket.tx_next", "socket.rx_next" and "socket.rx_wnd" fields respectively. 
-// It updates the "socket.state", "socket.tx_nxt", "socket.r2tq", and "socket.crqq" 
-// The supported TX command types are CONNECT / ACCEPT / SEND / CLOSE.
-// fields as required by the command type.
-// - For an UDP socket, it reset the "socket.tx_valid" field, and unblock the client
-//   thread when the packet has been sent, or when an error must be reported.
-// - For a TCP socket, it reset the "socket.tx_valid" field when the segment has been
-//   sent, but does not unblocks the client thread, that will be unblocqued by the 
-//   NIC_RX thread when the TX command is fully completed.
+
+///////////////////////////////////////////////////////////////////////////////////////////
+// This static function implement the TCP protocol as specified by the RFC.
+// It is called by the dev_nic_tx_server() function to handle one TX command, 
+// or one R2T request, for the socket identified by the <socket_xp> argument. 
+// It builds an ETH/IP/UDP packet or ETH/IP/TCP segment, in the 2 Kbytes kernel buffer,
+// defined by the <k_buf> argument from informations found in socket descriptor.
+// It returns a command status code (defined in the ksocket.h file), and returns in the
+// <total_length> argument the actual packet length.
+// It updates the "socket.state", "socket.tx_nxt", "socket.r2tq", "socket.crqq",
+// "socket.todo" fields as required by the command type, but it does NOT reset 
+// the "socket.tx_valid" field and does NOT unblock the client thread.
+// It does NOt take the socket lock, that is taken by the dev_nic_server().
 ///////////////////////////////////////////////////////////////////////////////////////////
 // To build a packet, it makes the following actions:
-// 1) it takes the lock protecting the socket state.
-// 2) it get the command arguments from socket descriptor.
-// 3) it build an UDP packet or a TCP segment, depending on command type and socket state. 
-// 4) it updates the socket state.
-// 5) it releases the lock protecting the socket.
-// 6) it build the IP header.
-// 7) it build the ETH header.
-// 8) it copies the packet in the NIC_TX queue.
-///////////////////////////////////////////////////////////////////////////////////////////
-// @ cmd_state   : [in] TX command valid in socket descriptor.
-// @ r2t_valid   : [in] R2T request valid in command descriptor. 
-// @ socket_xp   : [in] extended pointer on client socket.  
-// @ k_buf       : [in] local pointer on kernel buffer (2 Kbytes).
-// @ chdev       : [in] local pointer on NIC_RX chdev.
-///////////////////////////////////////////////////////////////////////////////////////////
-static void dev_nic_tx_build_packet( bool_t    cmd_valid,
-                                     bool_t    r2t_valid,
-                                     xptr_t    socket_xp,
-                                     uint8_t * k_buf,
-                                     chdev_t * chdev )
+// 1) it get the command arguments from socket descriptor.
+// 2) it build an UDP packet or a TCP segment, and update socket state. 
+// 3) it build the IP header.
+// 4) it build the ETH header.
+///////////////////////////////////////////////////////////////////////////////////////////
+// @ socket_xp    : [in]  extended pointer on client socket.  
+// @ k_buf        : [in]  local pointer on kernel buffer (2 Kbytes).
+// @ total_length : [out] total number of bytes written in k_buf.
+// @ return command status.
+///////////////////////////////////////////////////////////////////////////////////////////
+static socket_cmd_sts_t dev_nic_tx_build_packet( xptr_t     socket_xp,
+                                                 uint8_t  * k_buf,
+                                                 uint32_t * total_length )
 {
     socket_t  * socket_ptr;
     cxy_t       socket_cxy;
     xptr_t      client_xp;       // extended pointer on client thread  
+    bool_t      cmd_valid;       // valid user command
+    bool_t      r2t_valid;       // valid R2T queue request
     uint32_t    cmd_type;        // NIC command type
-    uint8_t   * tx_buf;          // local pointer on kernel buffer for payload
+    uint8_t   * tx_buf;          // local pointer on socket buffer for payload
     uint32_t    len;             // tx_buf length (bytes)
     uint32_t    todo;            // number of bytes not yet sent
     uint32_t    socket_type;     // socket type (UDP/TCP)
     uint32_t    socket_state;    // socket state        
-    xptr_t      socket_lock_xp;  // extended pointer on socket lock
     xptr_t      socket_r2tq_xp;  // extended pointer on R2T queue
     uint32_t    src_ip_addr;     // source IP address
@@ -2166,28 +2363,29 @@
     uint8_t     trsp_protocol;   // transport protocol type (UDP/TCP)
     uint8_t     r2t_flags;       // flags defined by one R2T queue request
-    bool_t      do_send;         // build & send a packet when true
-  
+ 
     // get socket cluster and local pointer
     socket_cxy = GET_CXY( socket_xp );
     socket_ptr = GET_PTR( socket_xp );
 
+#if DEBUG_DEV_NIC_TX  || DEBUG_DEV_NIC_ERROR
+uint32_t   cycle       = (uint32_t)hal_get_cycles();
+uint32_t   socket_fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ));
+uint32_t   socket_pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ));
+#endif
+
+    // build extended pointer on socket r2t queue 
+    socket_r2tq_xp = XPTR( socket_cxy , &socket_ptr->r2tq );
+
+    // get cmd_valid & t2t_valid from socket descriptor
+    cmd_valid = (bool_t)hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_valid ));
+    r2t_valid = (bool_t)remote_buf_status( XPTR( socket_cxy , &socket_ptr->r2tq ));
+
 #if DEBUG_DEV_NIC_TX 
-thread_t * this = CURRENT_THREAD;;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-uint32_t   fdid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ));
-uint32_t   pid   = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ));
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] enter for socket[%x,%d] : cmd_valid %d / r2t_valid %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, cmd_valid, r2t_valid, cycle );
-#endif
-
-    // build extended pointers on socket lock and r2t queue
-    socket_lock_xp = XPTR( socket_cxy , &socket_ptr->lock );    
-    socket_r2tq_xp = XPTR( socket_cxy , &socket_ptr->r2tq );
-
-    // 1. take lock protecting this socket
-    remote_queuelock_acquire( socket_lock_xp );
-
-    // get relevant socket infos
+printk("\n[%s] enter for socket[%x,%d] : cmd_val %d / r2t_val %d / cycle %d\n",
+__FUNCTION__, socket_pid, socket_fdid, cmd_valid, r2t_valid, cycle );
+#endif
+
+    // 1. get relevant socket infos
     socket_type  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->type ));
     socket_state = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->state ));
@@ -2195,15 +2393,13 @@
     dst_ip_addr  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->remote_addr ));
 
-    // compute UDP/TCP packet base in kernel buffer
+    // compute UDP/TCP packet base in local kernel buffer
     k_trsp_base = k_buf + ETH_HEAD_LEN + IP_HEAD_LEN;
 
-    // set default values
-    do_send     = false;
+    // default value
     trsp_length = 0;
-    nbytes      = 0;
-
-    if( cmd_valid )  // handle TX command 
-    {
-        // 2. get command arguments from socket
+
+    if( cmd_valid )  // handle TX command depending on type 
+    {
+        // get command arguments from socket
         cmd_type  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_cmd ));
         tx_buf    = hal_remote_lpt( XPTR( socket_cxy , &socket_ptr->tx_buf ));
@@ -2213,13 +2409,12 @@
         
 #if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] cmd_valid for socket[%x,%d] : %s / %s / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_cmd_type_str(cmd_type), socket_state_str(socket_state), cycle );
+printk("\n[%s] socket[%x,%d] / %s / command %s \n",
+__FUNCTION__, socket_pid, socket_fdid, 
+socket_cmd_type_str(cmd_type),socket_state_str(socket_state) );
 #endif
 
         //////////////////////////////////////////////////////////
-        // 3. UDP : build UDP packet and update UDP socket state
+        // 2. UDP : build UDP packet and update UDP socket state
         if( socket_type == SOCK_DGRAM )        
         {
@@ -2228,62 +2423,46 @@
             if( socket_state != UDP_STATE_ESTAB )
             {
-                // reset tx_valid
-                hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ) , false );
-
-                // unblock client thread / report error
-                dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADSTATE );
+                return  CMD_STS_BADSTATE;
             }
-            else
+            else if( cmd_type == CMD_TX_SEND ) 
             {
-                if( cmd_type == CMD_TX_SEND ) 
-                {
-                    // compute payload length
-                    nbytes = ( PAYLOAD_MAX_LEN < todo ) ? PAYLOAD_MAX_LEN : todo;
-
-                    // move payload from tx_buf to 2 Kbytes kernel buffer
-                    memcpy( k_trsp_base + UDP_HEAD_LEN,
-                            tx_buf + (len - todo),
-                            nbytes );
-
-                    // build UDP header 
-                    dev_nic_tx_build_udp_header( k_trsp_base,
-                                                 socket_xp,
-                                                 nbytes );
-
-                    // update "tx_todo" in socket descriptor 
-                    hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_todo), todo - nbytes );
-
-                    // send UDP packet 
-                    trsp_length = UDP_HEAD_LEN + nbytes;
-                    do_send     = true;
-
-#if( DEBUG_DEV_NIC_TX & 1)
-cycle = (uint32_t)hal_get_cycles();
+                // compute payload length
+                nbytes = ( CONFIG_SOCK_PAYLOAD_MAX < todo ) ? CONFIG_SOCK_PAYLOAD_MAX : todo;
+
+                // move payload from remote socket tx_buf to local kernel buffer
+                hal_remote_memcpy( XPTR( local_cxy  , k_trsp_base + UDP_HEAD_LEN ),
+                                   XPTR( socket_cxy , tx_buf + (len - todo) ),
+                                   nbytes );
+
+                // build UDP header 
+                dev_nic_tx_build_udp_header( k_trsp_base,
+                                             socket_xp,
+                                             nbytes );
+
+                // update "tx_todo" in socket descriptor 
+                hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_todo), todo - nbytes );
+
+                // set UDP packet length
+                trsp_length = UDP_HEAD_LEN + nbytes;
+
+#if DEBUG_DEV_NIC_TX 
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] UDP packet build / length %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, trsp_length , cycle );
-#endif
-                    if( nbytes == todo )    // last byte sent
-                    {
-                        // reset tx_valid
-                        hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ) , false );
-
-                        // report success to TX client
-                        dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
-                    }
-                }
-                else // CONNECT, ACCEPT, or CLOSE commands are illegal for UDP
-                {
-                    // reset tx_valid
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ) , false );
-
-                    // report error
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADCMD );
-                }
+printk("\n[%s] socket[%x,%d] UDP packet build / %d bytes\n",
+__FUNCTION__, socket_pid, socket_fdid, nbytes );
+#endif
+            }
+            else // CONNECT, ACCEPT, or CLOSE commands are illegal for UDP
+            {
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : bad state %s for socket[%x,%x] / cycle %d\n",
+__FUNCTION__, socket_state_str(socket_state), socket_pid, socket_fdid, cycle );
+#endif
+                return  CMD_STS_BADCMD;
             }
         }  // end UDP
 
         ///////////////////////////////////////////////////////////
-        // 3. TCP : build TCP segment and update TCP socket state
+        // 2. TCP : build TCP segment and update TCP socket state
         else if( socket_type == SOCK_STREAM ) 
         {
@@ -2296,6 +2475,6 @@
                 socket_r2tq_xp = XPTR( socket_cxy , &socket_ptr->r2tq );
         
-                // get one request from R2T queue 
-                remote_buf_get_to_kernel( socket_r2tq_xp , &r2t_flags , 1 );
+                // get one request from R2T queue, and update R2T queue
+                socket_get_r2t_request( socket_r2tq_xp , &r2t_flags );
             }
             else
@@ -2311,6 +2490,8 @@
                 {
                     // initialises socket tx_nxt, and rx_wnd
-                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->tx_nxt), TCP_ISS_CLIENT );
-                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->rx_wnd), TCP_MAX_WINDOW );
+                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->tx_nxt), 
+                                   CONFIG_SOCK_ISS_CLIENT );
+                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->rx_wnd),
+                                   CONFIG_SOCK_MAX_WINDOW );
 
                     // build TCP SYN segment
@@ -2319,16 +2500,7 @@
                                                  0,        // length
                                                  TCP_FLAG_SYN );   
-                    // send segment
+                    // set TCP packet length
                     trsp_length = TCP_HEAD_LEN;
-                    do_send     = true;
-
-#if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s / CONNECT / "
-"TCP SYN build / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str( socket_state ), cycle );
-#endif
+
                     // update socket.state 
                     hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
@@ -2337,16 +2509,19 @@
                     // update socket.tx_nxt
                     hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_nxt ),
-                                          TCP_ISS_CLIENT + 1 );
-
-                    // reset tx_valid but do not unblock client thread
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
+                                          CONFIG_SOCK_ISS_CLIENT + 1 );
+#if DEBUG_DEV_NIC_TX 
+if( cycle > DEBUG_DEV_NIC_TX )
+printk("\n[%s] socket[%x,%d] %s / CONNECT / TCP SYN build\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state) );
+#endif
                 } 
                 else                      // report error for all other socket states
                 {
-                    // reset tx_valid
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ) , false );
-                   
-                    // report error
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADSTATE ); 
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : bad state %s socket[%x,%x] / cycle %d\n",
+__FUNCTION__, socket_state_str(socket_state), socket_pid, socket_fdid, cycle );
+#endif
+                    return CMD_STS_BADSTATE; 
                 }
             }
@@ -2358,6 +2533,8 @@
                 {
                     // initialize socket tx_nxt, and rx_wnd
-                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->tx_nxt), TCP_ISS_SERVER );
-                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->rx_wnd), CONFIG_SOCK_RX_BUF_SIZE);
+                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->tx_nxt),
+                                        CONFIG_SOCK_ISS_SERVER );
+                    hal_remote_s32(XPTR(socket_cxy , &socket_ptr->rx_wnd),
+                                        (1 << CONFIG_SOCK_RX_BUF_ORDER) );
                 
                     // build TCP ACK-SYN segment
